<?php
namespace Teknisa\CNC\Controllers;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\CNC\Services;
use Teknisa\CNC\Utilities;

class ProdutoCNC extends \Zeedhi\Framework\Controller\Simple {
    
    protected $produtoService;
    protected $salesMessage;
    protected $util;
    
    public function __construct(Services\ProdutoCNC $produtoService, Utilities\SalesMessageCNC $salesMessage, Utilities\UtilCNC $util) {
        $this->produtoService = $produtoService;
        $this->salesMessage = $salesMessage;
        $this->util         = $util;
    }

    public function getProducts(Request\Filter $request, Response $response){
        try {
            $row = $request->getFilterCriteria()->getConditions();
            $row["LABELPRODUTOADQ"] = isset($row[0]["value"]) ? $row[0]["value"] : "%%";
            $Produto = $this->produtoService->getProducts($row);
            
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('ProdutosRepo', $Produto));
        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }

}