<?php

namespace Teknisa\CNC\Factories;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

use Doctrine\ORM\EntityManager;

class Cnc01800ReconciliacaoFactory {
    
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function reconciliar ($params) {
        $storedProcedure = new StoredProcedure($this->connection, 'RECONCILIACAO_CNC');
        
        $storedProcedure->addParam($params["P_SEQESTABELEC"]);
        $storedProcedure->addParam($params["P_DTINICIAL"]);
        $storedProcedure->addParam($params["P_DTFINAL"]);
        
        $storedProcedure->execute();
    }
    
    public function financeiro ($params) {
        $storedProcedure = new StoredProcedure($this->connection, 'GERA_FINANCEIRO_CNC');
        $storedProcedure->addParam($params["P_SEQESTABELEC"]);
        $storedProcedure->addParam($params["P_DTINICIAL"]);
        $storedProcedure->addParam($params["P_DTFINAL"]);
        $storedProcedure->execute();
    }
    
    public function validateAccountingPeriod ($params) {
        $sql = "SELECT 1 VAL
                FROM CONTOPECTBL C, ESTABELECIMENTO E, FILIAL F
                WHERE E.NRESTABELEC = :NRESTABELEC
                  AND E.CDFILIAL = F.CDFILIAL
                  AND C.CDEMPRESA = F.CDEMPRESA
                  AND :DT_INI >= C.DTINICCTBL
                  AND :DT_FIN <= C.DTFINACCTBL";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function verifyDivergences ($params) {
        $sql = "SELECT COUNT(*) COUNT
                FROM LOGERROCTBCNC
                WHERE NRESTABELEC = :NRESTABELEC";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function verifyEstabelecName($params) {
        $sql = "SELECT (CDESTABELEC ||' - ' || NMESTABELEC) AS NMESTABELEC
                FROM ESTABELECIMENTO
                WHERE NRESTABELEC = :NRESTABELEC";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }

}