<?php


/*interface DocumentosWS {
    
     ****************************************************** Métodos ********************************************************
     * Definição dos métodos que podem ser acessados por terceiros.                                                        *
     *                                                                                                                     *
     * getConteudoDocumentos                                                                                               *
     * @call  executeWs()                                                                                                  *
     * @desc: executa rotina para determinado cliente parametrizado                                                        *
     *                                                                                                                     *
     ***********************************************************************************************************************
    
}*/
 
set_time_limit(43200);
     
include('ACCESSTAGE_WS_CONSTS.php');

class AccesstageWS { 
    
    private static $tipoDocumento;    
    private static $arquivosVendas = [];
    private static $arquivosLotes = [];
    private static $arquivosPagamentos = [];
    private static $headersMsgs =[];
    private static $nrorg;
    private static $operador;
    private static $conn;
    private static $header;
    private static $produtos = [];
    private static $periodIni;
    private static $periodEnd;
    private static $count;
    private static $estabelecimentos = [];
    
    public function executeWs(){
        try{
            self::$count == 0;
            date_default_timezone_set("America/Sao_Paulo");
            
            // Define o período que o relatório vai verificar
            self::$periodIni = date('d/m/Y',strtotime("-1 days"));
            self::$periodEnd = date('d/m/Y',strtotime("+1 days"));
            /*Seta dados de login no header do soapclient para acessar os dados no webservice*/        
            AccesStageWS::setHeaderSoapClient();
    
            /* Conexao a ser usada quando o arquivo é aplicado no cliente */
            //self::$conn = oci_connect("/", "", USERNAME,"AL32UTF8", OCI_CRED_EXT);
    
            /* Conexao a ser usada quando o arquivo é aplicado para testes na Teknisa  */
            self::$conn = oci_connect('THEFIFTIES', 'teknisa', '192.168.122.5/pdborcl');
            
            
            /* Cria array associativo para buscar cada produto cadastrado no sistema */
            $sql = "SELECT CDPRODUTOADQ FROM PRODUTOADQ";
            $statement = oci_parse(self::$conn, $sql);
            oci_execute($statement, OCI_NO_AUTO_COMMIT);
            
            while($produto = oci_fetch_assoc($statement)){
                self::$produtos[$produto["CDPRODUTOADQ"]] = $produto["CDPRODUTOADQ"];
            }
            
            $arquivosVendas = null;
            $arquivosLotes = null;
            $arquivosPagamentos = null;
            $headersMsgs = null;
            
            $msgsDisponiveis = AccesstageWS::getListaDocumentos();
            $msgsDisponiveis = AccesstageWS::insereTrackingId($msgsDisponiveis);
            AccesstageWS::controlaConteudoMsgPorTrackId($msgsDisponiveis);  
            AccesstageWS::insertArquivosVendas();
            AccesstageWS::insertArquivosPagamentos();
            AccesstageWS::replicaDadosProc();
            //AccesStageWS::conciliacao();
            //AccesStageWS::geraFinanceiro();
            //APAGAR LINHA ABAIXO
            //AccesstageWS::confirmaRetiradaArquivo();
            
            oci_commit(self::$conn);
        }catch(\Exception $e) {
            oci_rollback(self::$conn);
            echo($e->getMessage());
        }
    }
    
    private static function setHeaderSoapClient(){
        /*
        * Gera conexão via SoapClient através da URL disponibilizada pela AccesStage 
        * A conexão fica preparada para ser possível acessar o procedimento "process".
        * Para mais informações sobre serviços soap e a documentação das
        * classes SoapClient e SoapServer e seus respectivos metódos,
        * consulte - http://php.net/manual/en/book.soap.php.
        */
        
        //Configurações para protocolo de segurança que é lido no header do Soap para todas as requisições
        $wsseNamespace = 'http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd';
        $security = new SoapVar(
            array(new SoapVar(
                array(
                    new SoapVar(ID_EMPRESA_CONC, XSD_STRING, null, null, 'Username', $wsseNamespace),
                    new SoapVar(SENHA_CONC, XSD_STRING, null, null, 'Password', $wsseNamespace)
                ), 
                SOAP_ENC_OBJECT, 
                null, 
                null, 
                'UsernameToken', 
                $wsseNamespace
            )), 
            SOAP_ENC_OBJECT
        );
        self::$header = new \SoapHeader($wsseNamespace, 'Security', $security, false);
    }

    //Função utilizada para obter a Tracking Id de todos os documentos do tipo esperado.
    //Retornará um array contendo, em cada posição, um número de TrackingId.
    private static function getListaDocumentos(){
       try{
            $sql = "select NVL(decode(SYS_CONTEXT('nrorg_ctx', 'nrorg'), 0, 1), 1) NRORG from dual";
            $statement = oci_parse(self::$conn, $sql);
            oci_execute($statement, OCI_NO_AUTO_COMMIT);
            self::$nrorg = oci_fetch_assoc($statement)['NRORG'];
    
            $listaDocDisponivel = new SoapClient(LISTAMSGDISPONIVEL, array("keep_alive" => true));
            $listaDocDisponivel->__setSoapHeaders(self::$header);
            if (!$listaDocDisponivel) {
                throw new \Exception("Não foi possível obter conexão para lista de mensagens disponiveis.");
            }
    
            $response = $listaDocDisponivel->__soapCall('process', array());
            $msgsDisponiveis = array();
            foreach ($response->MsgDisponivel as $eachResponse) {
                if($eachResponse->tipoDocumento !== 'CARTOES - EXTRATO' && $eachResponse->tipoDocumento !== 'EXTRATO FINANCEIRO'){
                    array_push($msgsDisponiveis, $eachResponse);
                }else{
                    array_push($msgsDisponiveis, $eachResponse);
                }
            }
            
            if(!$response){
                throw new \Exception("Não foi possível encontrar dados.");
            }
            return $msgsDisponiveis;
            
        }catch(\Exception $e){
            echo($e->getMessage());
        }
    }   
    
    private static function insereTrackingId($msgsDisponiveis){
        $mensagensDisponiveis = [];
        if(!empty($msgsDisponiveis)){
            foreach ($msgsDisponiveis as $msgDisponivel) {
            if(AccesstageWS::verifyTrackingId($msgDisponivel)){
                array_push($mensagensDisponiveis, $msgDisponivel);
                $IDATIVO = 'S';
                $NRCTRLTRCKIDACS = intval(AccesstageWS::newCode("CTRLTRCKIDACS"));
                $msgDisponivel->dtaHoraDisp = AccesstageWS::formatDate($msgDisponivel->dtaHoraDisp);
                $sql = "INSERT INTO CTRLTRCKIDACS (NRCTRLTRCKIDACS, DSTRACKINGID, DSTPDOCUMENTO, DSNMEMPRESAORIG, DTDISPONIVEL, DTULTATU, DTINCLUSAO, NRORG, NRORGINCLUSAO, NRORGULTATU, IDATIVO) 
                        VALUES (:NRCTRLTRCKIDACS, :DSTRACKINGID, :DSTPDOCUMENTO, :DSNMEMPRESAORIG, TO_DATE(:DTDISPONIVEL, 'DD/MM/YYYY HH24:MI:SS'), SYSDATE, SYSDATE, :NRORG, :NRORG, :NRORG, :IDATIVO) ";
                $statement = oci_parse(self::$conn, $sql);
                oci_bind_by_name($statement, ':NRCTRLTRCKIDACS', $NRCTRLTRCKIDACS);
                oci_bind_by_name($statement, ':DSTRACKINGID', $msgDisponivel->trkIdIn);
                oci_bind_by_name($statement, ':DSTPDOCUMENTO', $msgDisponivel->tipoDocumento);
                oci_bind_by_name($statement, ':DSNMEMPRESAORIG', $msgDisponivel->nmeEmpresaOrigem);
                oci_bind_by_name($statement, ':DTDISPONIVEL', $msgDisponivel->dtaHoraDisp);
                oci_bind_by_name($statement, ':NRORG', self::$nrorg);
                oci_bind_by_name($statement, ':IDATIVO', $IDATIVO);
                oci_execute($statement, OCI_NO_AUTO_COMMIT);
            }
        }
        }
        return $mensagensDisponiveis;

    }
    
    //Verifica se o documento já existe no banco de dados
    private static function verifyTrackingId($msgDisponivel){
        $trackingId = $msgDisponivel->trkIdIn;
        $sql = "SELECT COUNT(*) QT FROM CTRLTRCKIDACS WHERE DSTRACKINGID = :DSTRACKINGID";
        $statement = oci_parse(self::$conn, $sql);
        oci_bind_by_name($statement, ':DSTRACKINGID', $trackingId);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);
        $countIdTrack = oci_fetch_assoc($statement)['QT'];
        if($countIdTrack>0){
            return false;
        }else{
            return true;
        }
    }
    

    private static function controlaConteudoMsgPorTrackId($msgsDisponiveis){
        foreach ($msgsDisponiveis as $mensagemDisponivel) {
            $sql = "SELECT NRCTRLTRCKIDACS FROM CTRLTRCKIDACS WHERE DSTRACKINGID = :DSTRACKINGID";
            $statement = oci_parse(self::$conn, $sql);
            oci_bind_by_name($statement, ':DSTRACKINGID', $mensagemDisponivel->trkIdIn);
            oci_execute($statement, OCI_NO_AUTO_COMMIT);
            $NRCTRLTRCKIDACS = oci_fetch_assoc($statement)['NRCTRLTRCKIDACS'];
            $infoDocumento = new SoapClient(RECUPERAMSG, array("keep_alive" => true));
            if(!$infoDocumento){
                throw new \Exception("Não foi possível obter conexão para recuperar arquivos.");
            }
            $infoDocumento->__setSoapHeaders(self::$header);
            $trackingId = [ 'trackingId' => $mensagemDisponivel->trkIdIn ];
            $response = $infoDocumento->__soapCall('process', array($trackingId));
            /*
            * statusRequest : Utilizado para verificar se o documento foi encontrado com sucesso através do trackingId.
            * mensagemCodificada : Utilizado para verificar se o conteúdo do documento está codificado na base64.
            */
            
            $statusRequest = $response->dscStatusMensagem;
    		if($statusRequest =="Erro"){
    			throw new \Exception("Não foi possível encontrar dados para o tracking id: ".$trackingId["trackingId"]);
    		}
    		
    		$conteudoMensagem = $response->dscConteudoMensagem;
    		
            $mensagemCodificada = $response->flgCompactacao;
            if($mensagemCodificada){
                $conteudoMensagem = AccesstageWS::decodificaBase64($conteudoMensagem);
            }
            
            /*
             * $headerMensagem: Possui informações de cabeçalho do documento de origem.
             * $detailMensagem: Possui informações detalhadas do documento de origem.
             * $traillerMensagem: Possui informações resumidas do documento de origem.
             */
            $DSTRACKINGID = $mensagemDisponivel->trkIdIn;
            $conteudoMensagem = explode("\n", $conteudoMensagem);
            $headerMensagem = explode(";", $conteudoMensagem[0]);
            $headerMensagem = AccesStageWS::mapeiaHeader($headerMensagem);
            $NRHEADERACSTAGE = AccesStageWS::gravaHeaderDadosOrigem($headerMensagem);
            $headerMensagem['NRHEADERACSTAGE'] = $NRHEADERACSTAGE;
            array_push(self::$headersMsgs, $headerMensagem);
            /*Pega o detalhamento da mensagem, removendo o Cabecalho (Headder) e rodapé (Trailler)*/
            for($i = 0; $i < sizeof($conteudoMensagem); $i++){
                $detailMensagem = explode(";", $conteudoMensagem[$i]);
                
                // Tipo de registro Accesstage 02 ( Diferenciar do Header 2)
                if($detailMensagem[0] === "02"){
                    $detailMensagem = AccesStageWS::mapeiaDetail($detailMensagem);
                    $detailMensagem["NRHEADERACSTAGE"] = $NRHEADERACSTAGE;
                    // Separando Lotes e totalizadores das transações
                    $NRCONTMSGACSTAGE = AccesStageWS::gravaDetailDadosOrigem($detailMensagem, $NRHEADERACSTAGE, $DSTRACKINGID);
                    if ($detailMensagem["DSTPREGADQ"] == '41' || $detailMensagem["DSTPREGADQ"] == '45' || $detailMensagem["DSTPREGADQ"] == '47' || $detailMensagem["DSTPREGADQ"] == '46'){
                        array_push(self::$arquivosLotes, $detailMensagem); 
                    }
                    else {
                        $TPPAGAMENTO = AccesStageWS::identificaTPPagamento($headerMensagem, $detailMensagem);
                        /* Salva o arquivo em um array global para posteriormente ser utilizado para gravar suas informações no banco de dados */
                        if($TPPAGAMENTO == "Venda"){
                            array_push(self::$arquivosVendas, $detailMensagem); 
                        }else if($TPPAGAMENTO == "Pagamento"){
                            array_push(self::$arquivosPagamentos, $detailMensagem);
                        }
                    }

                }
            };
        
            /* Nao foi criada função para controlar o trailler pois o mesmo nao será usado */
            $traillerDoc = explode(";", end($conteudoMensagem));

            //DESCOMENTAR LINHA ABAIXO IRÁ RETIRAR OS ARQUIVOS DA ACCESSTAGE (CONFIRMAR MENSAGEM)
            //AccesStageWS::confirmaRetiradaArquivo($arquivo);
        }
    }
    
    private static function mapeiaHeader($headerMensagem){
        /* Mapeia array de acordo com nomeclatura utilizada pelo banco de dados */
        $camposHeader = ["DSOPERADORA", "DSTPREGACSTAGE", "DSTPREG", "DSDTEMISSAO", "DSTPEXTRATO", "DSNMCOMERCIAL", "DSSEQMOVIMENTO", "DSNRPVMATRIZ", "DSTPMOVIMENTO", "DSVERSAOARQUIVO"];
        $keys = array_values($camposHeader);
        $values = array_values($headerMensagem);
        if (count($values) !== count($keys)){
            var_dump($headerMensagem);
        }
        $headerMensagem = array_combine($keys, $values);
        return $headerMensagem;
    }
    
    private static function mapeiaDetail($detailMensagem){
        /* Mapeia array de acordo com nomeclatura utilizada pelo banco de dados */
        $camposDetail = ["DSTPREGACSTAGE", "DSTPREGADQ", "DSNRPVMATRIZ", "DSNMCOMMATRIZ", "DSNRPV", "DSNRRV", "DSNRBANCO", "DSNRAGENCIA", "DSNRCONTCORR", "DSDTRESVENDA", "DSQTCVNSU", "DSVRBRUT", "DSVRGORJETA", "DSVRREJEITADO", "DSVRLIQUIDO", "DSVRDESCONTO", "DSBANDPROD", "DSDTCREDITO", "DSBANDEIRA", "DSVRCVNSU", "DSNRCARTAO", "DSSTATUSCVNSU", "DSCVNSU", "DSNRREFERENCIA", "DSNRAUTORIZACAO", "DSHORATRANS", "DSTIPOCAPTURA", "DSNRTERMINAL", "DSDTCREDPRIMPAR", "DSDTCVNSU", "DSNRPARCELA", "DSVRLIQCVNSU", "DSVRLIQPRIMPAR", "DSVRLIQOUTRPAR", "DSVRPARCELA", "DSVRDESCPARCELA", "DSVRPARCELALIQ", "DSDTCREDITOB", "DSQTCVNSUREJEIT", "DSVRTOTROTATIVO", "DSVRTOTPARCSJURO", "DSVRTOTDOLAR", "DSTPRESUMO", "DSQTRESUVENDAAC", "DSVRBRUTPREDAT", "DSVRDESCPREDAT", "DSVRLIQPREDAT", "DSTPTRANS", "DSSTATUSTRANS", "DSVRCOMPRA", "DSVRSAQUE", "DSFORMACAPT", "DSDTPAGRV", "DSVRCOMIS", "DSVRCREDITO", "DSINDTPPAGTO", "DSCNPJESTAB", "DSDTTRANS", "DSVRTRANS", "DSNRPARCPAGA", "DSVRPARCPAGA", "DSDTPAGTO", "DSREDECAPORIG", "DSCODAFILIACAO", "DSESTABSUB", "DSDTAPRES", "DSDTPREVPGTO", "DSDTENVBANCO", "DSSINALVRBRUTO", "DSSINALTXADM", "DSSINALVRREJ", "DSSINALVRLIQ", "DSSTATUSPGTO", "DSIDENREVACEL", "DSORIGAJUSTE", "DSVRCOMPLEMT", "DSIDENTANT", "DSNROPANT", "DSSINALVRBRUTANT", "DSVRBRUTANT", "DSNRUNICORO", "DSTXADMIN", "DSTARADMIN", "DSTXGARANTIA", "DSNRLOGTERM", "DSMATRIZPGTO", "DSREENVIOPGTO", "DSCONCAPLICADO", "DSPLANO", "DSDTVENDAAJUSTE", "DSSINALCOMPPARC", "DSPARCELA", "DSMOTREJEICAO", "DSTID", "DSDIGCARTAO", "DSVRTOTVENDA", "DSVRPROXPARC", "DSNRNOTAFISCAL", "DSINDCARTEMIEXT", "DSNRLOGTERMINAL", "DSREFCODPED", "DSNRUNICOTRANS", "DSINDCIELOPROMO", "DSMODENTRCART", "DSCODVENDA", "DSCODINTAJUSTE" ];
        $keys = array_values($camposDetail);
        $values = array_values($detailMensagem);
        if (count($values) !== count($keys)){
            var_dump($detailMensagem);
        }
        $detailMensagem = array_combine($keys, $values);
        if(!$detailMensagem){
            throw new \Exception("Não foi possível mapear o detail");
        }
        return $detailMensagem;
    }
    
    private static function identificaProduto($CDPRODUTO){
        $sql = "SELECT NMPRODUTOADQ, NRPRODUTOADQ, CDPRODUTOADQ
        FROM PRODUTOADQ
        WHERE CDPRODUTOADQ = :CDPRODUTOADQ";
        $statement = oci_parse(self::$conn, $sql);
        
        oci_bind_by_name($statement, ':CDPRODUTOADQ', self::$produtos[$CDPRODUTO]);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);
        return oci_fetch_assoc($statement);
    }
    
    private static function identificaTPPagamento($headerOperadora, $detailMensagem){
        switch ($detailMensagem['DSTPTRANS']) {
            case '1':
                if($detailMensagem['DSSTATUSPGTO'] == '2'){
                    return "Pagamento";
                }else{
                    return "Venda";
                }
            break;
            
            case '24' || '25':
                return "Pagamento";
            break;
            
            case '':
                switch ($detailMensagem['DSTPREGADQ']) {
                    case '27'||'33'||'38':
                        return 'Pagamento';
                        break;
                    
                    //case 38 registro de movimento
                    
                    case '40' || '41':
                        return 'Venda';
                        
                }
            break;
            
            default:
                return "Pagamento";
            break;
        }
    
        
    }
    
    private static function identificaAdquirente($CDADQUIRENTE){
    /*  TABELA DE ADQUIRENTES (01/10/2018)
     *
     *  ADQUIRENTE  - CÓDIGO    |    ADQUIRENTE  -   CÓDIGO     |    ADQUIRENTE       -   CÓDIGO    |  ADQUIRENTE       -   CÓDIGO  
     *                          |                               |                                   |
     *  CIELO       -   1       |    BANRISUL    -   8          |    SENFF            -   21        |  VALECAR          -   31
     *  REDE        -   2       |    TICKET      -   11         |    GREEN CARD       -   22        |  TRICARD          -   32
     *  AMEX        -   3       |    SODEXO      -   13         |    DIRECT FÁCIL     -   24        |  PLANVALE         -   33
     *  GETNET      -   4       |    CREDISHOP   -   14         |    CABAL            -   26        |  SOROCRED         -   34
     *  ELAVON      -   5       |    PAGAR.ME    -   16         |    VR               -   28        |  PAGSEGURO        -   35
     *  BIN         -   6       |    BANESCARD   -   19         |    GLOBAL PAYMENTS  -   29        |  SAFRA PAY        -   36
     *  STONE       -   7       |    NUTRICASH   -   20         |    REDE UZE         -   30        |  VEROCHEQUE       -   37
     */ 
         
        $sql = "SELECT NRADQUIRENTE, NMADQUIRENTE FROM ADQUIRENTE WHERE CDADQUIRENTE = :CDADQUIRENTE";
        $statement = oci_parse(self::$conn, $sql);
        
        oci_bind_by_name($statement, ':CDADQUIRENTE', $CDADQUIRENTE);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);
        return oci_fetch_assoc($statement);
        
    }
    
    //Função utilizada para decodificar mensagens codificadas na base64. 
    //Para mais informações consulte a documentação sobre a função base64_decode: http://php.net/manual/pt_BR/function.base64-decode.php
    private static function decodificaBase64($msgCodificada){
        return base64_decode($msgCodificada);
    }
    
    /* function newCode($counterName, $size, $nrSeq, $qtd)
     * Gera um NRSEQUENCIAL para a tabela especifícada para ser usado em uma operação de insert.
     *
     * @param counterName: nome da tabela
     * @param size: tamanho do inteiro gerado. O default é 20
     * @param nrSeq: NRSEQUENCIAL inicial. O default é não passar nenhum paramêtro para que se gere o NRSEQUENCIAL imediatamente
     * anterior ao mais recente na tabela.
     * @param qtd: quantidade de códigos que serão gerados. O default é sempre 1
     *
     * @return o NRSEQUENCIAL gerado pela procedure que é armazenado na variável nrSeq
     */    
    private static function newCode($counterName, $size = 20, $nrSeq = '', $qtd = 1){
        $sql = 'CALL NOVO_CODIGO_NT(:P_CONTADOR, :P_SEQUENCIAL, :P_QTDE)';
        $statement = oci_parse(self::$conn, $sql);
        oci_bind_by_name($statement, ':P_CONTADOR', $counterName);
        oci_bind_by_name($statement, ':P_SEQUENCIAL', $nrSeq, $size);
        oci_bind_by_name($statement, ':P_QTDE', $qtd);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);
        if (!$nrSeq) {
            throw new \Exception("Não foi possível gerar chave primária para a tabela -> ".$counterName);
        }
        return $nrSeq;
    }
    
    private static function confirmaRetiradaArquivo($arquivo){
        $arquivo['NMARQUIVORET'] = 'TESTE';
        
        //Formata data para o padrão AccesStage
        $DTRETIRADA = date("Y-m-dTG:i:s.000P");
        $DTRETIRADA = str_replace('BRT','T', $DTRETIRADA);
        
        $arquivo['DTRETIRADA'] = $DTRETIRADA;
        
        $arquivo["DSTRACKINGID"] = $arquivo["DSTRACKINGID"];
        
        $msgConfirmada = new SoapClient(CONFIRMRETIRADA, array("keep_alive" => true));
        if(!$msgConfirmada){
            throw new \Exception("Não foi possível obter conexão para confirmar a retirada de arquivos.");
        }
        $msgConfirmada->__setSoapHeaders(self::$header);
        
        $parametro = ['trackingID' => $arquivo["DSTRACKINGID"], 'dataRetirada' => $arquivo['DTRETIRADA'], 'nmeArquivo' => $arquivo['NMARQUIVORET']];
        
        $response = $msgConfirmada->__soapCall('process', array($parametro));
        if($response->dscStatusRetirada != "Ok"){
            throw new \Exception("Não foi possível retirar o arquivo com o trakingId: ".$arquivo["DSTRACKINGID"]);
        }

        AccesStageWS::updateControleAcessWS($arquivo);

    }
    
    private static function updateControleAcessWS($arquivo){
        $sql = "UPDATE CTRLTRCKIDACS
                SET NMARQUIVORET = :NMARQUIVORET,
                    DTRETIRADA   = :DTRETIRADA
                WHERE DSTRACKINGID    = :DSTRACKINGID
                  AND NRCTRLTRCKIDACS = :NRCTRLTRCKIDACS";
        
        $statement = oci_parse(self::$conn, $sql);
        oci_bind_by_name($statement, ':NMARQUIVORET', $arquivo["NMARQUIVORET"]);
        oci_bind_by_name($statement, ':DTRETIRADA'  , $DTRETIRADA);
        oci_bind_by_name($statement, ':NMARQUIVORET', $arquivo["DSTRACKINGID"]);
        oci_bind_by_name($statement, ':NMARQUIVORET', $arquivo["NRCTRLTRCKIDACS"]);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);

    }
    
    private static function gravaHeaderDadosOrigem($headerMensagem){
        /*Grava os dados originarios do webservice no banco de dados para consistência de dados  */
        $NRHEADERACSTAGE = AccesStageWS::newCode("HEADERACSTAGE");
        $NRHEADERACSTAGE = intval($NRHEADERACSTAGE);
        $IDATIVO = 'S';
        $sql = "INSERT INTO HEADERACSTAGE
                (NRHEADERACSTAGE, DSOPERADORA, DSTPREGACSTAGE, DSTPREG, DSDTEMISSAO, DSTPEXTRATO, DSNMCOMERCIAL, DSSEQMOVIMENTO, DSNRPVMATRIZ, DSTPMOVIMENTO, DSVERSAOARQUIVO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, NRORGULTATU)
        VALUES (:NRHEADERACSTAGE, :DSOPERADORA, :DSTPREGACSTAGE, :DSTPREG, :DSDTEMISSAO, :DSTPEXTRATO, :DSNMCOMERCIAL, :DSSEQMOVIMENTO, :DSNRPVMATRIZ, :DSTPMOVIMENTO, :DSVERSAOARQUIVO, :NRORG, :IDATIVO, SYSDATE, SYSDATE, :NRORG, :NRORG )";
        $statement = oci_parse(self::$conn, $sql);
        oci_bind_by_name($statement, ':NRHEADERACSTAGE', $NRHEADERACSTAGE);
        oci_bind_by_name($statement, ':DSOPERADORA', $headerMensagem['DSOPERADORA']);
        oci_bind_by_name($statement, ':DSTPREGACSTAGE', $headerMensagem['DSTPREGACSTAGE']);
        oci_bind_by_name($statement, ':DSTPREG', $headerMensagem['DSTPREG']);
        oci_bind_by_name($statement, ':DSDTEMISSAO', $headerMensagem['DSDTEMISSAO']);
        oci_bind_by_name($statement, ':DSTPEXTRATO', $headerMensagem['DSTPEXTRATO']);
        oci_bind_by_name($statement, ':DSNMCOMERCIAL', $headerMensagem['DSNMCOMERCIAL']);
        oci_bind_by_name($statement, ':DSSEQMOVIMENTO', $headerMensagem['DSSEQMOVIMENTO']);
        oci_bind_by_name($statement, ':DSNRPVMATRIZ', $headerMensagem['DSNRPVMATRIZ']);
        oci_bind_by_name($statement, ':DSTPMOVIMENTO', $headerMensagem['DSTPMOVIMENTO']);
        oci_bind_by_name($statement, ':DSVERSAOARQUIVO', $headerMensagem['DSVERSAOARQUIVO']);
        oci_bind_by_name($statement, ':NRORG', self::$nrorg);
        oci_bind_by_name($statement, ':IDATIVO', $IDATIVO);

        oci_execute($statement, OCI_NO_AUTO_COMMIT);
        return $NRHEADERACSTAGE;
    }
    
    private static function gravaDetailDadosOrigem($detailMensagem, $NRHEADERACSTAGE, $DSTRACKINGID){
        $NRCONTMSGACSTAGE = AccesStageWS::newCode("CONTMSGACSTAGE");
        $IDATIVO = 'S';
        $sql = "INSERT INTO CONTMSGACSTAGE
                (NRCONTMSGACSTAGE, NRHEADERACSTAGE, DSTRACKINGID, DSTPREGACSTAGE, DSTPREGADQ, DSNRPVMATRIZ, DSNMCOMMATRIZ, DSNRPV, DSNRRV, DSNRBANCO, DSNRAGENCIA, DSNRCONTCORR, DSDTRESVENDA, DSQTCVNSU, DSVRBRUT, DSVRGORJETA, DSVRREJEITADO, DSVRLIQUIDO, DSVRDESCONTO, DSBANDPROD, DSDTCREDITO, DSBANDEIRA, DSVRCVNSU, DSNRCARTAO, DSSTATUSCVNSU, DSCVNSU, DSNRREFERENCIA, DSNRAUTORIZACAO, DSHORATRANS, DSTIPOCAPTURA, DSNRTERMINAL, DSDTCREDPRIMPAR, DSDTCVNSU, DSNRPARCELA, DSVRLIQCVNSU, DSVRLIQPRIMPAR, DSVRLIQOUTRPAR, DSVRPARCELA, DSVRDESCPARCELA, DSVRPARCELALIQ, DSQTCVNSUREJEIT, DSVRTOTROTATIVO, DSVRTOTPARCSJURO, DSVRTOTDOLAR, DSTPRESUMO, DSQTRESUVENDAAC, DSVRBRUTPREDAT, DSVRDESCPREDAT, DSVRLIQPREDAT, DSTPTRANS, DSSTATUSTRANS, DSVRCOMPRA, DSVRSAQUE, DSFORMACAPT, DSDTPAGRV, DSVRCOMIS, DSVRCREDITO, DSINDTPPAGTO, DSCNPJESTAB, DSDTTRANS, DSVRTRANS, DSNRPARCPAGA, DSVRPARCPAGA, DSDTPAGTO, DSREDECAPORIG, DSCODAFILIACAO, DSESTABSUB, DSDTAPRES, DSDTPREVPGTO, DSDTENVBANCO, DSSINALVRBRUTO, DSSINALTXADM, DSSINALVRREJ, DSSINALVRLIQ, DSSTATUSPGTO, DSIDENREVACEL, DSORIGAJUSTE, DSVRCOMPLEMT, DSIDENTANT, DSNROPANT, DSSINALVRBRUTANT, DSVRBRUTANT, DSNRUNICORO, DSTXADMIN, DSTARADMIN, DSTXGARANTIA, DSNRLOGTERM, DSMATRIZPGTO, DSREENVIOPGTO, DSCONCAPLICADO, DSPLANO, DSDTVENDAAJUSTE, DSSINALCOMPPARC, DSPARCELA, DSMOTREJEICAO, DSTID, DSDIGCARTAO, DSVRTOTVENDA, DSVRPROXPARC, DSNRNOTAFISCAL, DSINDCARTEMIEXT, DSNRLOGTERMINAL, DSREFCODPED, DSNRUNICOTRANS, DSINDCIELOPROMO, DSMODENTRCART, DSCODVENDA, DSCODINTAJUSTE, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, NRORGULTATU)
        VALUES (:NRCONTMSGACSTAGE, :NRHEADERACSTAGE, :DSTRACKINGID, :DSTPREGACSTAGE, :DSTPREGADQ, :DSNRPVMATRIZ, :DSNMCOMMATRIZ, :DSNRPV, :DSNRRV, :DSNRBANCO, :DSNRAGENCIA, :DSNRCONTCORR, :DSDTRESVENDA, :DSQTCVNSU, :DSVRBRUT, :DSVRGORJETA, :DSVRREJEITADO, :DSVRLIQUIDO, :DSVRDESCONTO, :DSBANDPROD, :DSDTCREDITO, :DSBANDEIRA, :DSVRCVNSU, :DSNRCARTAO, :DSSTATUSCVNSU, :DSCVNSU, :DSNRREFERENCIA, :DSNRAUTORIZACAO, :DSHORATRANS, :DSTIPOCAPTURA, :DSNRTERMINAL, :DSDTCREDPRIMPAR, :DSDTCVNSU, :DSNRPARCELA, :DSVRLIQCVNSU, :DSVRLIQPRIMPAR, :DSVRLIQOUTRPAR, :DSVRPARCELA, :DSVRDESCPARCELA, :DSVRPARCELALIQ, :DSQTCVNSUREJEIT, :DSVRTOTROTATIVO, :DSVRTOTPARCSJURO, :DSVRTOTDOLAR, :DSTPRESUMO, :DSQTRESUVENDAAC, :DSVRBRUTPREDAT, :DSVRDESCPREDAT, :DSVRLIQPREDAT, :DSTPTRANS, :DSSTATUSTRANS, :DSVRCOMPRA, :DSVRSAQUE, :DSFORMACAPT, :DSDTPAGRV, :DSVRCOMIS, :DSVRCREDITO, :DSINDTPPAGTO, :DSCNPJESTAB, :DSDTTRANS, :DSVRTRANS, :DSNRPARCPAGA, :DSVRPARCPAGA, :DSDTPAGTO, :DSREDECAPORIG, :DSCODAFILIACAO, :DSESTABSUB, :DSDTAPRES, :DSDTPREVPGTO, :DSDTENVBANCO, :DSSINALVRBRUTO, :DSSINALTXADM, :DSSINALVRREJ, :DSSINALVRLIQ, :DSSTATUSPGTO, :DSIDENREVACEL, :DSORIGAJUSTE, :DSVRCOMPLEMT, :DSIDENTANT, :DSNROPANT, :DSSINALVRBRUTANT, :DSVRBRUTANT, :DSNRUNICORO, :DSTXADMIN, :DSTARADMIN, :DSTXGARANTIA, :DSNRLOGTERM, :DSMATRIZPGTO, :DSREENVIOPGTO, :DSCONCAPLICADO, :DSPLANO, :DSDTVENDAAJUSTE, :DSSINALCOMPPARC, :DSPARCELA, :DSMOTREJEICAO, :DSTID, :DSDIGCARTAO, :DSVRTOTVENDA, :DSVRPROXPARC, :DSNRNOTAFISCAL, :DSINDCARTEMIEXT, :DSNRLOGTERMINAL, :DSREFCODPED, :DSNRUNICOTRANS, :DSINDCIELOPROMO, :DSMODENTRCART, :DSCODVENDA, :DSCODINTAJUSTE, :NRORG, :IDATIVO, SYSDATE, SYSDATE, :NRORG, :NRORG )";
        $statement = oci_parse(self::$conn, $sql);
        oci_bind_by_name($statement, ':NRCONTMSGACSTAGE', $NRCONTMSGACSTAGE);
        oci_bind_by_name($statement, ':NRHEADERACSTAGE', $NRHEADERACSTAGE);
        oci_bind_by_name($statement, ':DSTRACKINGID', $DSTRACKINGID);
        oci_bind_by_name($statement, ':DSTPREGACSTAGE', $detailMensagem['DSTPREGACSTAGE']);
        oci_bind_by_name($statement, ':DSTPREGADQ', $detailMensagem['DSTPREGADQ']);
        oci_bind_by_name($statement, ':DSNRPVMATRIZ', $detailMensagem['DSNRPVMATRIZ']);
        oci_bind_by_name($statement, ':DSNMCOMMATRIZ', $detailMensagem['DSNMCOMMATRIZ']);
        oci_bind_by_name($statement, ':DSNRPV', $detailMensagem['DSNRPV']);
        oci_bind_by_name($statement, ':DSNRRV', $detailMensagem['DSNRRV']);
        oci_bind_by_name($statement, ':DSNRBANCO', $detailMensagem['DSNRBANCO']);
        oci_bind_by_name($statement, ':DSNRAGENCIA', $detailMensagem["DSNRAGENCIA"]);
        oci_bind_by_name($statement, ':DSNRCONTCORR', $detailMensagem["DSNRCONTCORR"]);
        oci_bind_by_name($statement, ':DSDTRESVENDA', $detailMensagem["DSDTRESVENDA"]);
        oci_bind_by_name($statement, ':DSQTCVNSU', $detailMensagem["DSQTCVNSU"]);
        oci_bind_by_name($statement, ':DSVRBRUT', $detailMensagem["DSVRBRUT"]);
        oci_bind_by_name($statement, ':DSVRGORJETA', $detailMensagem["DSVRGORJETA"]);
        oci_bind_by_name($statement, ':DSVRREJEITADO', $detailMensagem["DSVRREJEITADO"]);
        oci_bind_by_name($statement, ':DSVRLIQUIDO', $detailMensagem["DSVRLIQUIDO"]);
        oci_bind_by_name($statement, ':DSVRDESCONTO', $detailMensagem["DSVRDESCONTO"]);
        oci_bind_by_name($statement, ':DSBANDPROD', $detailMensagem["DSBANDPROD"]);
        oci_bind_by_name($statement, ':DSDTCREDITO', $detailMensagem["DSDTCREDITO"]);
        oci_bind_by_name($statement, ':DSBANDEIRA', $detailMensagem["DSBANDEIRA"]);
        oci_bind_by_name($statement, ':DSVRCVNSU', $detailMensagem["DSVRCVNSU"]);
        oci_bind_by_name($statement, ':DSNRCARTAO', $detailMensagem["DSNRCARTAO"]);
        oci_bind_by_name($statement, ':DSSTATUSCVNSU', $detailMensagem["DSSTATUSCVNSU"]);
        oci_bind_by_name($statement, ':DSCVNSU', $detailMensagem["DSCVNSU"]);
        oci_bind_by_name($statement, ':DSNRREFERENCIA', $detailMensagem["DSNRREFERENCIA"]);
        oci_bind_by_name($statement, ':DSNRAUTORIZACAO', $detailMensagem["DSNRAUTORIZACAO"]);
        oci_bind_by_name($statement, ':DSHORATRANS', $detailMensagem["DSHORATRANS"]);
        oci_bind_by_name($statement, ':DSTIPOCAPTURA', $detailMensagem["DSTIPOCAPTURA"]);
        oci_bind_by_name($statement, ':DSNRTERMINAL', $detailMensagem["DSNRTERMINAL"]);
        oci_bind_by_name($statement, ':DSDTCREDPRIMPAR', $detailMensagem["DSDTCREDPRIMPAR"]);
        oci_bind_by_name($statement, ':DSDTCVNSU', $detailMensagem["DSDTCVNSU"]);
        oci_bind_by_name($statement, ':DSNRPARCELA', $detailMensagem["DSNRPARCELA"]);
        oci_bind_by_name($statement, ':DSVRLIQCVNSU', $detailMensagem["DSVRLIQCVNSU"]);
        oci_bind_by_name($statement, ':DSVRLIQPRIMPAR', $detailMensagem["DSVRLIQPRIMPAR"]);
        oci_bind_by_name($statement, ':DSVRLIQOUTRPAR', $detailMensagem["DSVRLIQOUTRPAR"]);
        oci_bind_by_name($statement, ':DSVRPARCELA', $detailMensagem["DSVRPARCELA"]);
        oci_bind_by_name($statement, ':DSVRDESCPARCELA', $detailMensagem["DSVRDESCPARCELA"]);
        oci_bind_by_name($statement, ':DSVRPARCELALIQ', $detailMensagem["DSVRPARCELALIQ"]);
        //oci_bind_by_name($statement, ':DSDTCREDITOB', $detailMensagem["DSDTCREDITOB"]);
        oci_bind_by_name($statement, ':DSQTCVNSUREJEIT', $detailMensagem["DSQTCVNSUREJEIT"]);
        oci_bind_by_name($statement, ':DSVRTOTROTATIVO', $detailMensagem["DSVRTOTROTATIVO"]);
        oci_bind_by_name($statement, ':DSVRTOTPARCSJURO', $detailMensagem["DSVRTOTPARCSJURO"]);
        oci_bind_by_name($statement, ':DSVRTOTDOLAR', $detailMensagem["DSVRTOTDOLAR"]);
        oci_bind_by_name($statement, ':DSTPRESUMO', $detailMensagem["DSTPRESUMO"]);
        oci_bind_by_name($statement, ':DSQTRESUVENDAAC', $detailMensagem["DSQTRESUVENDAAC"]);
        oci_bind_by_name($statement, ':DSVRBRUTPREDAT', $detailMensagem["DSVRBRUTPREDAT"]);
        oci_bind_by_name($statement, ':DSVRDESCPREDAT', $detailMensagem["DSVRDESCPREDAT"]);
        oci_bind_by_name($statement, ':DSVRLIQPREDAT', $detailMensagem["DSVRLIQPREDAT"]);
        oci_bind_by_name($statement, ':DSTPTRANS', $detailMensagem["DSTPTRANS"]);
        oci_bind_by_name($statement, ':DSSTATUSTRANS', $detailMensagem["DSSTATUSTRANS"]);
        oci_bind_by_name($statement, ':DSVRCOMPRA', $detailMensagem["DSVRCOMPRA"]);
        oci_bind_by_name($statement, ':DSVRSAQUE', $detailMensagem["DSVRSAQUE"]);
        oci_bind_by_name($statement, ':DSFORMACAPT', $detailMensagem["DSFORMACAPT"]);
        oci_bind_by_name($statement, ':DSDTPAGRV', $detailMensagem["DSDTPAGRV"]);
        oci_bind_by_name($statement, ':DSVRCOMIS', $detailMensagem["DSVRCOMIS"]);
        oci_bind_by_name($statement, ':DSVRCREDITO', $detailMensagem["DSVRCREDITO"]);
        oci_bind_by_name($statement, ':DSINDTPPAGTO', $detailMensagem["DSINDTPPAGTO"]);
        oci_bind_by_name($statement, ':DSCNPJESTAB', $detailMensagem["DSCNPJESTAB"]);
        oci_bind_by_name($statement, ':DSDTTRANS', $detailMensagem["DSDTTRANS"]);
        oci_bind_by_name($statement, ':DSVRTRANS', $detailMensagem["DSVRTRANS"]);
        oci_bind_by_name($statement, ':DSNRPARCPAGA', $detailMensagem["DSNRPARCPAGA"]);
        oci_bind_by_name($statement, ':DSVRPARCPAGA', $detailMensagem["DSVRPARCPAGA"]);
        oci_bind_by_name($statement, ':DSDTPAGTO', $detailMensagem["DSDTPAGTO"]);
        oci_bind_by_name($statement, ':DSREDECAPORIG', $detailMensagem["DSREDECAPORIG"]);
        oci_bind_by_name($statement, ':DSCODAFILIACAO', $detailMensagem["DSCODAFILIACAO"]);
        oci_bind_by_name($statement, ':DSESTABSUB', $detailMensagem["DSESTABSUB"]);
        oci_bind_by_name($statement, ':DSDTAPRES', $detailMensagem["DSDTAPRES"]);
        oci_bind_by_name($statement, ':DSDTPREVPGTO', $detailMensagem["DSDTPREVPGTO"]);
        oci_bind_by_name($statement, ':DSDTENVBANCO', $detailMensagem["DSDTENVBANCO"]);
        oci_bind_by_name($statement, ':DSSINALVRBRUTO', $detailMensagem["DSSINALVRBRUTO"]);
        oci_bind_by_name($statement, ':DSSINALTXADM', $detailMensagem["DSSINALTXADM"]);
        oci_bind_by_name($statement, ':DSSINALVRREJ', $detailMensagem["DSSINALVRREJ"]);
        oci_bind_by_name($statement, ':DSSINALVRLIQ', $detailMensagem["DSSINALVRLIQ"]);
        oci_bind_by_name($statement, ':DSSTATUSPGTO', $detailMensagem["DSSTATUSPGTO"]);
        oci_bind_by_name($statement, ':DSIDENREVACEL', $detailMensagem["DSIDENREVACEL"]);
        oci_bind_by_name($statement, ':DSORIGAJUSTE', $detailMensagem["DSORIGAJUSTE"]);
        oci_bind_by_name($statement, ':DSVRCOMPLEMT', $detailMensagem["DSVRCOMPLEMT"]);
        oci_bind_by_name($statement, ':DSIDENTANT', $detailMensagem["DSIDENTANT"]);
        oci_bind_by_name($statement, ':DSNROPANT', $detailMensagem["DSNROPANT"]);
        oci_bind_by_name($statement, ':DSSINALVRBRUTANT', $detailMensagem["DSSINALVRBRUTANT"]);
        oci_bind_by_name($statement, ':DSVRBRUTANT', $detailMensagem["DSVRBRUTANT"]);
        oci_bind_by_name($statement, ':DSNRUNICORO', $detailMensagem["DSNRUNICORO"]);
        oci_bind_by_name($statement, ':DSTXADMIN', $detailMensagem["DSTXADMIN"]);
        oci_bind_by_name($statement, ':DSTARADMIN', $detailMensagem["DSTARADMIN"]);
        oci_bind_by_name($statement, ':DSTXGARANTIA', $detailMensagem["DSTXGARANTIA"]);
        oci_bind_by_name($statement, ':DSNRLOGTERM', $detailMensagem["DSNRLOGTERM"]);
        oci_bind_by_name($statement, ':DSMATRIZPGTO', $detailMensagem["DSMATRIZPGTO"]);
        oci_bind_by_name($statement, ':DSREENVIOPGTO', $detailMensagem["DSREENVIOPGTO"]);
        oci_bind_by_name($statement, ':DSCONCAPLICADO', $detailMensagem["DSCONCAPLICADO"]);
        oci_bind_by_name($statement, ':DSPLANO', $detailMensagem["DSPLANO"]);
        oci_bind_by_name($statement, ':DSDTVENDAAJUSTE', $detailMensagem["DSDTVENDAAJUSTE"]);
        oci_bind_by_name($statement, ':DSSINALCOMPPARC', $detailMensagem["DSSINALCOMPPARC"]);
        oci_bind_by_name($statement, ':DSPARCELA', $detailMensagem["DSPARCELA"]);
        oci_bind_by_name($statement, ':DSMOTREJEICAO', $detailMensagem["DSMOTREJEICAO"]);
        oci_bind_by_name($statement, ':DSTID', $detailMensagem["DSTID"]);
        oci_bind_by_name($statement, ':DSDIGCARTAO', $detailMensagem["DSDIGCARTAO"]);
        oci_bind_by_name($statement, ':DSVRTOTVENDA', $detailMensagem["DSVRTOTVENDA"]);
        oci_bind_by_name($statement, ':DSVRPROXPARC', $detailMensagem["DSVRPROXPARC"]);
        oci_bind_by_name($statement, ':DSNRNOTAFISCAL', $detailMensagem["DSNRNOTAFISCAL"]);
        oci_bind_by_name($statement, ':DSINDCARTEMIEXT', $detailMensagem["DSINDCARTEMIEXT"]);
        oci_bind_by_name($statement, ':DSNRLOGTERMINAL', $detailMensagem["DSNRLOGTERMINAL"]);
        oci_bind_by_name($statement, ':DSREFCODPED', $detailMensagem["DSREFCODPED"]);
        oci_bind_by_name($statement, ':DSNRUNICOTRANS', $detailMensagem["DSNRUNICOTRANS"]);
        oci_bind_by_name($statement, ':DSINDCIELOPROMO', $detailMensagem["DSINDCIELOPROMO"]);
        oci_bind_by_name($statement, ':DSMODENTRCART', $detailMensagem["DSMODENTRCART"]);
        oci_bind_by_name($statement, ':DSCODVENDA', $detailMensagem["DSCODVENDA"]);
        oci_bind_by_name($statement, ':DSCODINTAJUSTE',  $detailMensagem["DSCODINTAJUSTE"]);
        oci_bind_by_name($statement, ':NRORG', self::$nrorg);
        oci_bind_by_name($statement, ':IDATIVO', $IDATIVO);
        oci_execute($statement, OCI_NO_AUTO_COMMIT); 
        
        return $NRCONTMSGACSTAGE;
    }
    
    private static function insertArquivosVendas(){
        $bool = true;
        foreach(self::$arquivosVendas as $arquivoVenda){
            $sql = "SELECT DSOPERADORA FROM HEADERACSTAGE WHERE NRHEADERACSTAGE = :NRHEADERACSTAGE";
            $statement = oci_parse(self::$conn, $sql);
            oci_bind_by_name($statement, ':NRHEADERACSTAGE', $arquivoVenda['NRHEADERACSTAGE']);
            oci_execute($statement, OCI_NO_AUTO_COMMIT); 
            $DSOPERADORA = oci_fetch_assoc($statement)['DSOPERADORA'];
            /*Identifica o código da adquirente de acordo com o padrão da Teknisa */
            $adquirente = AccesStageWS::identificaAdquirente($DSOPERADORA);
            /* Identifica o código, nome e numero do produto de acordo com o padrão da Teknisa */
            $produtoadq = AccesStageWS::identificaProduto($arquivoVenda['DSBANDPROD']);
            
            $arquivoVenda["NMADQUIRENTE"] = $adquirente["NMADQUIRENTE"];
            $arquivoVenda["NRADQUIRENTE"] = $adquirente["NRADQUIRENTE"];
            $arquivoVenda["CDPRODUTOADQ"] = $produtoadq["CDPRODUTOADQ"];
            $arquivoVenda["NMPRODUTOADQ"] = $produtoadq["NMPRODUTOADQ"];
            $arquivoVenda["NRPRODUTOADQ"] = $produtoadq["NRPRODUTOADQ"];
            
            $IDATIVO = 'S';
            $IDSTATUS = 'P'; //REVER
            $IDREJEITADO = $arquivoVenda['DSSTATUSPGTO'] == '102'|| '100' || '87'? 'S' : 'N';
            $IDCANCELADO = $arquivoVenda['DSSTATUSPGTO'] ==  '97' || '98' || '99'? 'S' : 'N';
            $DTVENDA = AccesStageWS::verificaDtVenda($arquivoVenda);
            $DTCREDITO = AccesStageWS::verificaDtCredito($arquivoVenda);
            $NRESTABELEC = AccesStageWS::verificaEstabelec($arquivoVenda);
            // Verifica se é necessário inserir o estabelecimento do relatório atual, e inseri em caso positivo
            in_array($NRESTABELEC, self::$estabelecimentos) ? true : self::$estabelecimentos[] = $NRESTABELEC;
            
            AccesStageWS::verificaInfoFilial($arquivoVenda, $NRESTABELEC);
            $arquivoVenda = AccesStageWS::padronizaValores($arquivoVenda);
            $MODALIDADE = AccesStageWS::identificaModalidade($produtoadq, $arquivoVenda);
            $VRTAXAADM = AccesStageWS::calculaTaxa($arquivoVenda);
            $CDNSU = AccesStageWS::identificaCdnsu($arquivoVenda);
            $NRQTPARCELA = AccesStageWS::verificaQtparcela($arquivoVenda);
            $NRPARCELA = AccesStageWS::verificaNrparcela($arquivoVenda);
            $DTHORATRANS = $arquivoVenda['DSDTAPRES'] == ""? $arquivoVenda['DSDTTRANS'].' '.$arquivoVenda['DSHORATRANS']: $arquivoVenda['DSDTAPRES'];
            $NRRETORIGVENDA = (int)AccesStageWS::newCode('RETORIGVENDA');
            $sql = "INSERT INTO RETORIGVENDA (NRRETORIGVENDA, NRHEADERACSTAGE, NRESTABELEC, NMADQUIRENTE, NRADQUIRENTE, CDPRODUTOADQ, NMPRODUTOADQ, NRPRODUTOADQ, IDMODALIDADE, DSMODALIDADE, DTVENDA, DTCREDITO, CDLOTEVENDA, NRAUTORIZACAO, NRCARTAOTRUNC, CDNSU, VRBRUTVENDA, VRTAXAADM, VRCOBRADOTAXA, VRLIQVENDA, NRTERMINAL, CDBANCO, CDAGENCIA, CDCONTCORR, DTHORATRANS, NRPARCELA, NRQTPARCELA, IDSTATUS, IDREJEITADO, IDCANCELADO, DTPGTO, VRLIQPGTO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, NRORGULTATU) 
                                    VALUES (:NRRETORIGVENDA, :NRHEADERACSTAGE, :NRESTABELEC, :NMADQUIRENTE, :NRADQUIRENTE, :CDPRODUTOADQ, :NMPRODUTOADQ, :NRPRODUTOADQ, :IDMODALIDADE, :DSMODALIDADE, TO_DATE(:DTVENDA, 'DD/MM/YYYY'), TO_DATE(:DTCREDITO, 'DD/MM/YYYY'), :CDLOTEVENDA, :NRAUTORIZACAO, :NRCARTAOTRUNC, :CDNSU, TO_NUMBER(:VRBRUTVENDA), :VRTAXAADM, :VRCOBRADOTAXA, :VRLIQVENDA, :NRTERMINAL, :CDBANCO, :CDAGENCIA, :CDCONTCORR, TO_DATE(:DTHORATRANS, 'DDMMYYYY HH24MISS'), :NRPARCELA, :NRQTPARCELA, :IDSTATUS, :IDREJEITADO, :IDCANCELADO, TO_DATE(:DTPGTO, 'DDMMYYYY HH24MISS'), TO_NUMBER(:VRLIQPGTO), TO_NUMBER(:NRORG), :IDATIVO, SYSDATE, SYSDATE, :NRORG, :NRORG)";
            $statement = oci_parse(self::$conn, $sql);
            oci_bind_by_name($statement, ':NRRETORIGVENDA', $NRRETORIGVENDA);
            oci_bind_by_name($statement, ':NRHEADERACSTAGE', $arquivoVenda["NRHEADERACSTAGE"]);
            oci_bind_by_name($statement, ':NRESTABELEC', $NRESTABELEC);
            oci_bind_by_name($statement, ':NMADQUIRENTE', $arquivoVenda['NMADQUIRENTE']);
            oci_bind_by_name($statement, ':NRADQUIRENTE', $arquivoVenda['NRADQUIRENTE']);
            oci_bind_by_name($statement, ':CDPRODUTOADQ', $arquivoVenda['CDPRODUTOADQ']);
            oci_bind_by_name($statement, ':NMPRODUTOADQ', $arquivoVenda['NMPRODUTOADQ']);
            oci_bind_by_name($statement, ':NRPRODUTOADQ', $arquivoVenda['NRPRODUTOADQ']);
            oci_bind_by_name($statement, ':IDMODALIDADE', $MODALIDADE['IDMODALIDADE']); 
            oci_bind_by_name($statement, ':DSMODALIDADE', $MODALIDADE['DSMODALIDADE']);
            oci_bind_by_name($statement, ':DTVENDA', $DTVENDA); 
            oci_bind_by_name($statement, ':DTCREDITO', $DTCREDITO);
            oci_bind_by_name($statement, ':CDLOTEVENDA', $arquivoVenda['DSNRRV']); 
            oci_bind_by_name($statement, ':NRAUTORIZACAO', $arquivoVenda['DSNRAUTORIZACAO']);
            oci_bind_by_name($statement, ':NRCARTAOTRUNC', $arquivoVenda['DSNRCARTAO']);
            oci_bind_by_name($statement, ':CDNSU', $CDNSU);
            oci_bind_by_name($statement, ':VRBRUTVENDA', $arquivoVenda['DSVRBRUT']); 
            oci_bind_by_name($statement, ':VRTAXAADM', $VRTAXAADM);
            oci_bind_by_name($statement, ':VRCOBRADOTAXA', $arquivoVenda['DSVRDESCONTO']);
            oci_bind_by_name($statement, ':VRLIQVENDA', $arquivoVenda['DSVRLIQUIDO']);
            oci_bind_by_name($statement, ':NRTERMINAL', $arquivoVenda['DSNRTERMINAL']);
            oci_bind_by_name($statement, ':CDBANCO', $arquivoVenda['DSNRBANCO']);
            oci_bind_by_name($statement, ':CDAGENCIA', $arquivoVenda['DSNRAGENCIA']);
            oci_bind_by_name($statement, ':CDCONTCORR', $arquivoVenda['DSNRCONTCORR']);
            oci_bind_by_name($statement, ':DTHORATRANS', $DTHORATRANS);
            oci_bind_by_name($statement, ':NRPARCELA', $NRPARCELA); 
            oci_bind_by_name($statement, ':NRQTPARCELA', $NRQTPARCELA);
            oci_bind_by_name($statement, ':IDSTATUS', $IDSTATUS); //REVER
            oci_bind_by_name($statement, ':IDREJEITADO', $IDREJEITADO);
            oci_bind_by_name($statement, ':IDCANCELADO', $IDCANCELADO); 
            oci_bind_by_name($statement, ':DTPGTO', $arquivoVenda['DSDTPAGTO']);
            oci_bind_by_name($statement, ':VRLIQPGTO', $arquivoVenda['DSVRCREDITO']);
            oci_bind_by_name($statement, ':NRORG', self::$nrorg); 
            oci_bind_by_name($statement, ':IDATIVO', $IDATIVO);
            $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
            
        }
        $bool ? var_dump("O retorno de Vendas foi inserido com sucesso. \n") : var_dump("Ocorreu um erro ao tentar inserir o retorno de Vendas.\n");


    }
    
    private static function insertArquivosPagamentos(){
        $bool = true;
        foreach(self::$arquivosPagamentos as $arquivoPagamento){
            $sql = "SELECT DSOPERADORA, DSTPEXTRATO FROM HEADERACSTAGE WHERE NRHEADERACSTAGE = :NRHEADERACSTAGE  ";
            $statement = oci_parse(self::$conn, $sql);
            oci_bind_by_name($statement, ':NRHEADERACSTAGE', $arquivoPagamento['NRHEADERACSTAGE']);
            oci_execute($statement, OCI_NO_AUTO_COMMIT); 
            $DSOPERADORA = oci_fetch_assoc($statement)['DSOPERADORA'];
            $DSTPEXTRATO = oci_fetch_assoc($statement)['DSTPEXTRATO'];
            /*Identifica o código da adquirente de acordo com o padrão da Teknisa */
            $adquirente = AccesStageWS::identificaAdquirente($DSOPERADORA);
            /* Identifica o código, nome e numero do produto de acordo com o padrão da Teknisa */
            $produtoadq = AccesStageWS::identificaProduto($arquivoPagamento['DSBANDPROD']);
            $arquivoPagamento["NMADQUIRENTE"] = $adquirente["NMADQUIRENTE"];
            $arquivoPagamento["NRADQUIRENTE"] = $adquirente["NRADQUIRENTE"];
            $arquivoPagamento["CDPRODUTOADQ"] = $produtoadq["CDPRODUTOADQ"];
            $arquivoPagamento["NMPRODUTOADQ"] = $produtoadq["NMPRODUTOADQ"];
            $arquivoPagamento["NRPRODUTOADQ"] = $produtoadq["NRPRODUTOADQ"];
            $IDATIVO = 'S';
            $IDANTECIPADO = AccesStageWS::identificaIdantecipado($arquivoPagamento, $DSTPEXTRATO);
            
            
            
            /*  CNC_WS ESTÁ ASSIM:
            switch ($payment[':IdTipoTransacao']) {
                case '1':
                    $payment[':IdTipoTransacao'] = 'V'; // Venda      ******* NO BANCO O DSTIPOTRANS TA GRAVADO COMO PAGAMENTOS
                    break;
               
                case '3':
                    $payment[':IdTipoTransacao'] = 'C'; // Cancelamentos 
                    break;
                case '4':
                    $payment[':IdTipoTransacao'] = 'D'; // Débitos 
                    break;
            }
            */
            
            $NRESTABELEC = AccesStageWS::verificaEstabelec($arquivoPagamento);
            // Verifica se é necessário inserir o estabelecimento do relatório atual, e inseri em caso positivo
            in_array($NRESTABELEC, self::$estabelecimentos) ? true : self::$estabelecimentos[] = $NRESTABELEC;
            
            AccesStageWS::verificaInfoFilial($arquivoPagamento, $NRESTABELEC);
            $arquivoPagamento = AccesStageWS::padronizaValores($arquivoPagamento);
            $MODALIDADE = AccesStageWS::identificaModalidade($produtoadq, $arquivoPagamento);
            $VRTAXAADM = AccesStageWS::calculaTaxa($arquivoPagamento);
            $TRANSACAO = AccesStageWS::identificaTipoTransacao($arquivoPagamento, $MODALIDADE);
            $DTVENDA = AccesStageWS::verificaDtVenda($arquivoPagamento);
            $DTCREDITO = AccesStageWS::verificaDtCredito($arquivoPagamento);
            $CDNSU = AccesStageWS::identificaCdnsu($arquivoPagamento);
            $NRQTPARCELA = AccesStageWS::verificaQtparcela($arquivoPagamento);
            $NRPARCELA = AccesStageWS::verificaNrparcela($arquivoPagamento);
            $IDTIPOTRANS = $TRANSACAO['IDTIPOTRANS'];
            $DSTRANSACAO = $TRANSACAO['DSTRANSACAO'];
            $NRRETORIGFINANC = (int)AccesStageWS::newCode('RETORIGFINANC');
            $sql = "INSERT INTO RETORIGFINANC (NRRETORIGFINANC, NRHEADERACSTAGE, NRESTABELEC, NMADQUIRENTE, NRADQUIRENTE, CDPRODUTOADQ, NMPRODUTOADQ, NRPRODUTOADQ, DTVENDA, DTCREDITO, CDLOTEVENDA, NRAUTORIZACAO, CDNSU, NRTID, VRBRUTVENDA, VRTAXAADM, VRCOBRADOTAXA, VRLIQVENDA, CDBANCO, CDAGENCIA, CDCONTCORR, NRPARCELA, NRQTPARCELA, IDANTECIPADO, IDTIPOTRANS, DSTRANSACAO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, NRORGULTATU )
                                      VALUES (:NRRETORIGFINANC, :NRHEADERACSTAGE, :NRESTABELEC, :NMADQUIRENTE, :NRADQUIRENTE, :CDPRODUTOADQ, :NMPRODUTOADQ, :NRPRODUTOADQ, TO_DATE(:DTVENDA, 'DD/MM/YYYY'), TO_DATE(:DTCREDITO, 'DD/MM/YYYY'), :CDLOTEVENDA, :NRAUTORIZACAO, :CDNSU, :NRTID, TO_NUMBER(:VRBRUTVENDA), :VRTAXAADM, :VRCOBRADOTAXA, :VRLIQVENDA, :CDBANCO, :CDAGENCIA, :CDCONTCORR, :NRPARCELA, :NRQTPARCELA, :IDANTECIPADO, :IDTIPOTRANS, :DSTRANSACAO, :NRORG, :IDATIVO, SYSDATE, SYSDATE, :NRORG, :NRORG )";
            $statement = oci_parse(self::$conn, $sql);
            oci_bind_by_name($statement, ':NRRETORIGFINANC', $NRRETORIGFINANC);
            oci_bind_by_name($statement, ':NRHEADERACSTAGE', $arquivoPagamento["NRHEADERACSTAGE"]);
            oci_bind_by_name($statement, ':NRESTABELEC', $NRESTABELEC);
            oci_bind_by_name($statement, ':NMADQUIRENTE', $arquivoPagamento['NMADQUIRENTE']);
            oci_bind_by_name($statement, ':NRADQUIRENTE', $arquivoPagamento['NRADQUIRENTE']);
            oci_bind_by_name($statement, ':CDPRODUTOADQ', $arquivoPagamento['CDPRODUTOADQ']);
            oci_bind_by_name($statement, ':NMPRODUTOADQ', $arquivoPagamento['NMPRODUTOADQ']);
            oci_bind_by_name($statement, ':NRPRODUTOADQ', $arquivoPagamento['NRPRODUTOADQ']);
            oci_bind_by_name($statement, ':DTVENDA', $DTVENDA); 
            oci_bind_by_name($statement, ':DTCREDITO', $DTCREDITO);
            oci_bind_by_name($statement, ':CDLOTEVENDA', $arquivoPagamento['DSNRRV']); 
            oci_bind_by_name($statement, ':NRAUTORIZACAO', $arquivoPagamento['DSNRAUTORIZACAO']);
            oci_bind_by_name($statement, ':CDNSU', $CDNSU);
            oci_bind_by_name($statement, ':NRTID', $arquivoPagamento['DSTID']);  
            oci_bind_by_name($statement, ':VRBRUTVENDA', $arquivoPagamento['DSVRBRUT']); 
            oci_bind_by_name($statement, ':VRTAXAADM', $VRTAXAADM);
            oci_bind_by_name($statement, ':VRCOBRADOTAXA', $arquivoPagamento['DSVRDESCONTO']);
            oci_bind_by_name($statement, ':VRLIQVENDA', $arquivoPagamento['DSVRLIQUIDO']);
            oci_bind_by_name($statement, ':CDBANCO', $arquivoPagamento['DSNRBANCO']);
            oci_bind_by_name($statement, ':CDAGENCIA', $arquivoPagamento['DSNRAGENCIA']);
            oci_bind_by_name($statement, ':CDCONTCORR', $arquivoPagamento['DSNRCONTCORR']);
            oci_bind_by_name($statement, ':NRPARCELA', $NRPARCELA); 
            oci_bind_by_name($statement, ':NRQTPARCELA', $NRQTPARCELA);
            oci_bind_by_name($statement, ':IDANTECIPADO', $IDANTECIPADO); 
            oci_bind_by_name($statement, ':IDTIPOTRANS', $IDTIPOTRANS);
            oci_bind_by_name($statement, ':DSTRANSACAO', $DSTRANSACAO);
            oci_bind_by_name($statement, ':NRORG', self::$nrorg); 
            oci_bind_by_name($statement, ':IDATIVO', $IDATIVO);
            $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
            
        }
        
        $bool ? var_dump("O retorno de Pagamentos foi inserido com sucesso.\n") : var_dump("Ocorreu um erro ao tentar inserir o retorno de Pagamentos.\n");


    }

    private static function identificaIdantecipado($arquivo, $DSTPEXTRATO){
        return $arquivo['DSTPTRANS'] == '25'? 'S' : $DSTPEXTRATO == '06'? 'S' : 'N';
    }
    
    private static function verificaDtVenda($arquivo){
        if($arquivo['DSDTVENDAAJUSTE']){
            return $arquivo['DSDTVENDAAJUSTE'];
        }else{
            return $arquivo['DSDTTRANS'];
        } 
    }
    
    private static function verificaDtCredito($arquivo){
        if($arquivo['DSDTCREDITO']){
            return $arquivo['DSDTCREDITO'];
        }else{
            return $arquivo['DSDTPAGRV'];
        } 
    }
    
    private static function padronizaValores($arquivo){
        $arquivo['DSVRBRUT']        = AccesStageWS::inteiroParaMonetario($arquivo['DSVRBRUT']);
        $arquivo['DSVRDESCONTO']    = $arquivo['DSVRDESCONTO'] == ""? AccesStageWS::inteiroParaMonetario($arquivo['DSVRGORJETA']) : AccesStageWS::inteiroParaMonetario($arquivo['DSVRDESCONTO']);
        $arquivo['DSVRLIQUIDO']     = AccesStageWS::inteiroParaMonetario($arquivo['DSVRLIQUIDO']);
        $arquivo['DSVRCVNSU']       = AccesStageWS::retiraZeroEsquerda($arquivo['DSVRCVNSU']);
        $arquivo['DSNRAUTORIZACAO'] = AccesStageWS::retiraZeroEsquerda($arquivo['DSNRAUTORIZACAO']);
        $arquivo['DSNRBANCO']       = AccesStageWS::retiraZeroEsquerda($arquivo['DSNRBANCO']);
        $arquivo['DSNRAGENCIA']     = AccesStageWS::retiraZeroEsquerda($arquivo['DSNRAGENCIA']);
        $arquivo['DSNRCONTCORR']    = AccesStageWS::retiraZeroEsquerda($arquivo['DSNRCONTCORR']);
        $arquivo['DSVRCREDITO']     = AccesStageWS::inteiroParaMonetario($arquivo['DSVRCREDITO']);
        return $arquivo;
    }
    
    private static function retiraZeroEsquerda($valor){
        return ltrim($valor, '0');
    }
    
    private static function inteiroParaMonetario($valor){
        return $valor/100;
    }
    
    private static function calculaTaxa($arquivo){
        if($arquivo['DSTXADMIN']){
            return round(($arquivo['DSTXADMIN']/100), 2);
        }else{
            return round((($arquivo['DSVRDESCONTO']*100)/$arquivo['DSVRBRUT'] == 0 ? 1 : $arquivo['DSVRBRUT']), 2);
        }
    }
    
    private static function verificaEstabelec($arquivo){
        $operadora = AccesStageWS::buscaOperadora($arquivo);
        if($arquivo['DSESTABSUB']){
            $CDESTABELEC = $arquivo['DSESTABSUB'];
        }else{
            $CDESTABELEC = $arquivo['DSNRPV'];
        }
        
        $sql = "SELECT NRESTABELEC FROM ESTABELECIMENTO WHERE TO_NUMBER(CDESTABELEC) = TO_NUMBER(:CDESTABELEC)";
        $statement = oci_parse(self::$conn, $sql);
        oci_bind_by_name($statement, ':CDESTABELEC', $CDESTABELEC);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);
        $NRESTABELEC = oci_fetch_assoc($statement)['NRESTABELEC'];

        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }
        
        if ($NRESTABELEC == NULL) {
            $nrSeq = AccesStageWS::newCode('ESTABELECIMENTO');
            $sql = "INSERT INTO ESTABELECIMENTO (NRESTABELEC, CDESTABELEC, NRORG, IDATIVO) VALUES (:NRESTABELEC, TO_CHAR(TO_NUMBER(:CDESTABELEC)), :NRORG, 'S')";
            $statement = oci_parse(self::$conn, $sql);
            oci_bind_by_name($statement, ':NRESTABELEC', $nrSeq);
            oci_bind_by_name($statement, ':CDESTABELEC', strval($CDESTABELEC));
            oci_bind_by_name($statement, ':NRORG', self::$nrorg);
            oci_execute($statement, OCI_NO_AUTO_COMMIT);
            return $nrSeq;

            $e = oci_error($statement);
            if ($e) {
                throw new \Exception($e["message"]);
            }
            
        }else{
            return $NRESTABELEC;
        }
        
    }

    private static function verificaInfoFilial($arquivo, $NRESTABELEC){
        
        $sql = "SELECT CDFILIAL, NMFILIAL, CDEMPRESA, CDINSCESTA, CDINSCMUNI, NRINSJURFILI FROM FILIAL WHERE NRORG = :NRORG AND NRINSJURFILI = :CNPJ";
        $statement = oci_parse(self::$conn, $sql);
        oci_bind_by_name($statement, ':NRORG', self::$nrorg);
        oci_bind_by_name($statement, ':CNPJ', $arquivo["DSCNPJESTAB"]);
        oci_execute($statement, OCI_NO_AUTO_COMMIT);

        $e = oci_error($statement);
        if ($e) {
            throw new \Exception($e["message"]);
        }

        $filial = oci_fetch_assoc($statement);
        $filial["NMFILIAL"] = empty($filial["NMFILIAL"]) ? "" : $filial["NMFILIAL"];
        
        if ($filial) {
            $sql = "UPDATE ESTABELECIMENTO SET CDFILIAL = :CDFILIAL, NMESTABELEC = :NMESTABELEC, NRCNPJESTABELEC = :CNPJ, CDEMPRESA = :CDEMPRESA, CDINSCESTA = :CDINSCESTA, CDINSCMUNI = :CDINSCMUNI WHERE NRORG = :NRORG AND NRESTABELEC = :NRESTABELEC";
            $statement = oci_parse(self::$conn, $sql);
            oci_bind_by_name($statement, ':CDFILIAL', $filial["CDFILIAL"]);
            oci_bind_by_name($statement, ":NMESTABELEC", $filial["NMFILIAL"]);
            oci_bind_by_name($statement, ':CNPJ', $arquivo["DETAIL"]["DSCNPJESTAB"]);
            oci_bind_by_name($statement, ':CDEMPRESA', $filial["CDEMPRESA"]);
            oci_bind_by_name($statement, ":CDINSCESTA", $filial["CDINSCESTA"]);
            oci_bind_by_name($statement, ':CDINSCMUNI', $filial["CDINSCMUNI"]);
            oci_bind_by_name($statement, ':NRORG', self::$nrorg);
            oci_bind_by_name($statement, ':NRESTABELEC', $NRESTABELEC);
            oci_execute($statement, OCI_NO_AUTO_COMMIT);
            
            $e = oci_error($statement);
            
            if ($e) {
                throw new \Exception($e["message"]);
            }
        }
    }
    
    private static function replicaDadosProc () {
        $bool = true;
        foreach(self::$headersMsgs as $header) {    
            $nrSeqControle = null;
            $sql = "BEGIN REPLICA_DADOS_CNC(TO_DATE(:P_DTINICIAL, 'DD/MM/YYYY'), TO_DATE(:P_DTFINAL, 'DD/MM/YYYY'), :P_NRSEQCONTROLE, :P_NRHEADERACSTAGE); END;";
            $statement = oci_parse(self::$conn, $sql);

            oci_bind_by_name($statement, ':P_DTINICIAL', self::$periodIni);
            oci_bind_by_name($statement, ':P_DTFINAL', self::$periodEnd);
            oci_bind_by_name($statement, ':P_NRSEQCONTROLE', $nrSeqControle);
            oci_bind_by_name($statement, ':P_NRHEADERACSTAGE', $header['NRHEADERACSTAGE']);
            $bool = oci_execute($statement, OCI_NO_AUTO_COMMIT);
            
            $e = oci_error($statement);
            if ($e) {
                throw new \Exception($e["message"]);
            }
        }

        $bool ? var_dump("A replicação foi feita com sucesso.\n") : var_dump("Ocorreu um erro ao tentar aplicar a replicação.\n");
    }
    
    private static function verificaQtparcela($arquivo){
        return $arquivo['DSNRPARCELA']? $arquivo['DSNRPARCELA'] : 0;
    }

    private static function verificaNrparcela($arquivo){
        return $arquivo['DSPARCELA']? $arquivo['DSPARCELA'] : 0;
    }
    
    private static function identificaModalidade($produtoadq, $arquivo){
        if($arquivo['DSNRPARCELA'] > 1){
            $MODALIDADE['IDMODALIDADE'] = 'P'; 
            $MODALIDADE['DSMODALIDADE'] = 'Credito Parcelado';
            return $MODALIDADE;
        }
        switch($produtoadq['CDPRODUTOADQ']){
            case 1||4||7||11||13||15||16||20||21||24||66||197||327:

                $MODALIDADE['IDMODALIDADE'] = 'C';
                $MODALIDADE['DSMODALIDADE'] = 'Credito';
                return $MODALIDADE;
                break;
            case 2||5||8||322:
                $MODALIDADE['IDMODALIDADE'] = 'D';
                $MODALIDADE['DSMODALIDADE'] = 'Debito';
                return $MODALIDADE;
                break;
            default:
                $MODALIDADE['IDMODALIDADE'] = 'B';
                $MODALIDADE['DSMODALIDADE'] = 'Beneficio';
                return $MODALIDADE;
                break;
        }
    }
    
    private static function identificaCdnsu($arquivo){
        if($arquivo['DSVRCVNSU']){
            $CDNSU = $arquivo['DSVRCVNSU'];
        }else if($arquivo['DSCVNSU']){
            $CDNSU = $arquivo['DSCVNSU'];
        }
        return $CDNSU;
    }
    
    private static function identificaTipoTransacao($arquivo, $MODALIDADE){
        if($arquivo['DSVRBRUT'] > 0){
            if($MODALIDADE['IDMODALIDADE'] == ('D'||'B') ){
                $TIPOTRANSACAO['IDTIPOTRANS'] = 'V';
                $TIPOTRANSACAO['DSTRANSACAO'] = 'Pagamento';
            }else{
                $TIPOTRANSACAO['IDTIPOTRANS'] = 'P';
                $TIPOTRANSACAO['DSTRANSACAO'] = 'Credito';
            }
        }else{
            $TIPOTRANSACAO['IDTIPOTRANS'] = 'C';
            $TIPOTRANSACAO['DSTRANSACAO'] = 'Cancelamento';
        }
        return $TIPOTRANSACAO;
    }
    
    private static function buscaOperadora($arquivo){
        $sql = "SELECT DSOPERADORA FROM HEADERACSTAGE WHERE NRHEADERACSTAGE = :NRHEADERACSTAGE  ";
        $statement = oci_parse(self::$conn, $sql);
        oci_bind_by_name($statement, ':NRHEADERACSTAGE', $arquivo['NRHEADERACSTAGE']);
        oci_execute($statement, OCI_NO_AUTO_COMMIT); 
        $DSOPERADORA = oci_fetch_assoc($statement)['DSOPERADORA'];
        return $DSOPERADORA;
    }
    
    private static function conciliacao() {
        echo "............. Realizando as conciliações............. \n";
        $bool = true;
        foreach (self::$estabelecimentos as $estabelecimento) {
            echo "...... Estabelecimento: ".$estabelecimento."\n";
            
            $sql = "BEGIN CONCILIACAO_CNC (:P_NRESTABELEC, TO_DATE(:P_DTINICIAL, 'DD/MM/YYYY'), TO_DATE(:P_DTFINAL, 'DD/MM/YYYY')); END;";
            $statement = oci_parse(self::$conn, $sql);
            
            $P_DTINICIAL = self::$periodIni;
            $P_DTFINAL = self::$periodEnd;
            
            oci_bind_by_name($statement, ':P_NRESTABELEC', $estabelecimento);
            oci_bind_by_name($statement, ':P_DTINICIAL', $P_DTINICIAL);
            oci_bind_by_name($statement, ':P_DTFINAL', $P_DTFINAL);
            $bool = $bool && oci_execute($statement, OCI_NO_AUTO_COMMIT);
            $e = oci_error($statement);
            if ($e) {
                throw new \Exception($e["message"]);
            }
        }
        $bool ? var_dump('A conciliação dos dados foi feita com sucesso.') : var_dump('Ocorreu um erro ao tentar executar a rotina de conciliação.');
        return $bool;
    }

    private static function geraFinanceiro() {
        echo "............. Realizando a geração do financeiro (REC e BCO)............. \n";
        $bool = true;  
        foreach (self::$estabelecimentos as $estabelecimento) {
            echo "...... Estabelecimento: ".$estabelecimento."\n";
            
            $sql = "BEGIN GERA_FINANCEIRO_CNC(:P_ESTABELEC, TO_DATE(:P_DTINICIAL, 'DD/MM/YYYY'), TO_DATE(:P_DTFINAL, 'DD/MM/YYYY')); END;";
            $statement = oci_parse(self::$conn, $sql);
            $P_DTINICIAL = self::$periodIni;
            $P_DTFINAL = self::$periodEnd;
            oci_bind_by_name($statement, ':P_ESTABELEC', $estabelecimento);
            oci_bind_by_name($statement, ':P_DTINICIAL', $P_DTINICIAL);
            oci_bind_by_name($statement, ':P_DTFINAL', $P_DTFINAL);
            $bool = $bool && oci_execute($statement, OCI_NO_AUTO_COMMIT);
            $e = oci_error($statement);
            if ($e) {
                throw new \Exception($e["message"]);
            }
        }
        $bool ? var_dump('A geração de valores do Financeiro foi feita com sucesso.') : var_dump('Ocorreu um erro ao tentar gerar os valores do Financeiro.');
        return $bool;
    }
    
    //Formata data recebida pelo webservice (padrão AAAA-MM-DDTHH:MIN:SS.000-02:00) 
    //para o padrão utilizado pelo banco de dados (padrão DD/MM/AAAA HH:MIN:SS)
    private static function formatDate($date){
        return date('d/m/Y H:i:s', strtotime($date));

    }

}

AccesstageWS::executeWs();