<?php
namespace App\Controller;

use \Exception as Exception;
use Psr\Http\Message\ResponseInterface as Response;
use Psr\Http\Message\ServerRequestInterface as Request;

class MyTest {
    protected $myService;

	public function __construct(\App\Service\MyTest $myService) {
        $this->myService = $myService;
	}
	
    public function nothing(Request $request, Response $response) {
        try {
            $consumerParams['CDCLIENTE']    = 'O00001';
            $consumerParams['CDCONSUMIDOR'] = 'SDE000000000000000335';

            return $response->withJson(array(
                'success' => true,
                'message' => '',
                'result'  => $this->myService->getConsumer($consumerParams)
            ));
        } catch (Exception $e) {
            return $response->withJson(array(
                'success' => false,
                'message' => $e->getMessage(),
                'result'  => []
            ));
        }
    }

    public function minhaRota(Request $request, Response $response) {
        try {
            $params  = $request->getParsedBody();
            // $version = isset($params['version']) ? $params['version'] : null;
            $version = $params['version'];
                
            $message = 'Versão suportada.';
            if($version != '2.6.5') {
                $message = 'Versão não suportada.';
            }

            return $response->withJson(array(
                'success' => true,
                'message' => $message,
                'result'  => []
            ));
        } catch (Exception $e) {
            return $response->withJson(array(
                'success' => false,
                'message' => $e->getMessage(),
                'result'  => []
            ));
        }
    }
}
